/* Slave zur Multiplikation von Matrixzeilen */
/* include pvm header file */
#include </usr/local/share/solaris/pvm3/include/pvm3.h>
#include <stdio.h>
#include <stdlib.h>

int main(void){
/*  nodeprogramm fuer pvm-programm "master3"
    um daten vom master zuempfangen, zuveraendern und 
    wieder zurueckzuschicken */

    int n, rowsPerSlave;
    int **A, *B, *C;
    int i, j, mytid, parentId;
    
/*  enroll this program in pvm 3 */
    mytid = pvm_mytid();

/*  get the master's task id */
    parentId = pvm_parent();

/*  begin user program */

/*  Daten von Master erhalten */
    // Matrixspalten von A erhalten
    pvm_recv( parentId, 4 );
    pvm_upkint( &n, 1, 1 );
    // zu verarbeitende Zeilen erhalten
    //pvm_recv( parentId, 2 );
    pvm_upkint( &rowsPerSlave, 1, 1 );
    // Speicher an Matrizen zuweisen
    A = (int**)malloc(rowsPerSlave*sizeof(int*));
    for(i=0; i<rowsPerSlave; i++)
        A[i] = (int*)malloc(n*sizeof(int));
    B = (int*)malloc(n*sizeof(int));
    C = (int*)malloc(rowsPerSlave*sizeof(int));
    
    // Teilmatrix A erhalten
    for(i=0; i<rowsPerSlave; i++){
        //pvm_recv( parentId, 3 );
        pvm_upkint( &A[i][0], n, 1 );
    }
    // Vektor B erhalten
    //pvm_recv( parentId, 4 );
    pvm_upkint( &B[0], n, 1 );

    /*  Resultat fr Zeilen berechnen */
    for(i=0; i<rowsPerSlave; i++){
        C[i] = 0;
        for(j=0; j<n; j++){
            C[i] += A[i][j] * B[j];
        }
    }

    /*  Ergebnisvektor an Parent senden */
    pvm_initsend( PvmDataRaw );
    pvm_pkint( &C[0], rowsPerSlave, 1 );
    pvm_send( parentId, 5 );

    /*  end user program */

    /*  program finished, leave before exiting */
    pvm_exit();
    return 0;
}
